#
# upgrade ssdpcm software - remove old versions
# Credit to Josh-Daniel S. Davis at http://eserver.livejournal.com/37616.html
# for the suggestion to replace the sddpcm pre deinstallation script
# script could be more cautious and only attempt to uninstall if the preview
# uninstall of both filesets succeeds
#
# st7392020@gmail.com
##############################################################################
#!/usr/bin/ksh

exit_fail()
{
	[ -f ${pre_d}.backup ] && mv ${pre_d}.backup $pre_d
}

# MAIN

desired_fileset=devices.sddpcm.71
desired_version=2.6.7.0
remove_sdd=''
lslpp -Lqc "devices.sddpcm*" 2>/dev/null | while read line
do
	sdd_fileset=`echo $line|cut -d: -f1`
	[ x$sdd_fileset = x$desired_fileset ] || remove_sdd=true
	sdd_version=`echo $line|cut -d: -f3`
	[ x$sdd_version = $desired_version ] || remove_sdd=true
done
desired_fileset=devices.fcp.disk.ibm.mpio
desired_version=1.0.0.24
remove_mpio=''
lslpp -Lqc "devices.fcp.disk.ibm.mpio*" 2>/dev/null | while read line
do
	mpio_fileset=`echo $line|cut -d: -f1`
	[ x$mpio_fileset = x$desired_fileset ] || remove_mpio=true
	mpio_version=`echo $line|cut -d: -f3`
	[ x$mpio_version = $desired_version ] || remove_mpio=true
done

[ "$remove_sdd$remove_mpio" ] || return

if [ "$remove_sdd" ] ; then
	# by inspection on multiple systems at multiple versions this is always true
	ls /usr/lpp/devices.sddpcm*/deinstl/*pre_d | wc -l | read count
	[ $count -ne 1 ] && return
	pre_d=`ls /usr/lpp/devices.sddpcm*/deinstl/*pre_d`
	cp $pre_d ${pre_d}.backup || return
	cat > $pre_d << EoF
#!/usr/bin/ksh
return 0
EoF
	chmod 750 $pre_d
	chown root.system $pre_d
	# preview uninstall. Only uninstall if preview succeeds
	installp -up $sdd_fileset | grep FAILED && exit_fail
	installp -u $sdd_fileset
	installp -aXd . devices.sddpcm.71
fi
if [ "$remove_mpio" ] ; then
	installp -up $mpio_fileset | grep FAILED && exit_fail
	installp -u $mpio_fileset
	installp -aXd . devices.fcp.disk.ibm.mpio.rte
fi

[ -f ${pre_d}.backup ] && rm ${pre_d}.backup
